$TestApp = {
    Class = RealTimeApplication
    +Functions = {
        Class = ReferenceContainer
        +GAMTimer = {
            Class = IOGAM
            InputSignals = {
                Counter = {                  DataSource = Timer Type = uint32 }                
                Time 	= { Frequency = 10    DataSource = Timer Type = uint32 }
            }
            OutputSignals = {
                Counter = {                  DataSource = DDB1  Type = uint32 }                
                Time    = {                	 DataSource = DDB1  Type = uint32 }            
            }
        }
        +TimeConversion = {
            Class = ConversionGAM
                InputSignals = {
                    Time    = { DataSource = DDB1 Type = uint32 }
                }
                OutputSignals = {
                    TimeSec = { DataSource = DDB1 Type = float32 Gain = "0.000001" }
                }
        }
	    +Constants = {
	     Class = ConstantGAM
	     OutputSignals = {
				zero	= { DataSource = DDB1 Type = float32  NumberOfElements = 1 NumberOfDimensions = 0 Default=0 }				
                Trigger = { DataSource = DDB1 Type = uint8    NumberOfElements = 1 NumberOfDimensions = 0 Default=1 }
                //in1     = { DataSource = DDB1 Type = uint8    NumberOfElements = 8 NumberOfDimensions = 1 Default={0 0 0 0 0 0 0 0}  }
                //in2     = { DataSource = DDB1 Type = float32  NumberOfElements = 2 NumberOfDimensions = 1 Default={0 0}  }                
                in2     = { DataSource = DDB1 Type = uint8    NumberOfElements = 16 NumberOfDimensions=1 Default={0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0}  }                
                //in3 = { DataSource = DDB1 Type = float32    NumberOfElements = 1 NumberOfDimensions = 0 Default=0  }
                //in4 = { DataSource = DDB1 Type = float32    NumberOfElements = 4 NumberOfDimensions = 1 Default={0 0 0 0}  }  
                //in5 = { DataSource = DDB1 Type = uint8    NumberOfElements = 1 NumberOfDimensions = 0 Default=0  }
//                in6     = { DataSource = DDB1 Type = uint8  NumberOfElements = 16 NumberOfDimensions = 1 Default={0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0}  }                                
                in6     = { DataSource = DDB1 Type = uint8  NumberOfElements = 8 NumberOfDimensions = 1 Default={0 0 0 0 0 0 0 0 }  }  
                in7 = { DataSource = DDB1 Type = float32     NumberOfElements = 2 NumberOfDimensions = 1 Default={0 0} }

                }
	    }
	    +BusExciter = {
	     Class = IOGAM
	     InputSignals = {
	       TimeSec6 = { DataSource = DDB1 Type = float32 Alias = TimeSec }
	       Counter2 = { DataSource = DDB1 Type = uint32  Alias = Counter }
	       TimeSec1 = { DataSource = DDB1 Type = float32 Alias = TimeSec }
	       TimeSec2 = { DataSource = DDB1 Type = float32 Alias = TimeSec }
	       TimeSec3 = { DataSource = DDB1 Type = float32 Alias = TimeSec }
	       TimeSec4 = { DataSource = DDB1 Type = float32 Alias = TimeSec }
	       TimeSec5 = { DataSource = DDB1 Type = float32 Alias = TimeSec }
	       Counter1 = { DataSource = DDB1 Type = uint32  Alias = Counter }
	       
	     }
	     OutputSignals = {
           in1     = { DataSource = DDB1 Type = uint8    NumberOfElements = 8 NumberOfDimensions = 1 }
           in3 = { DataSource = DDB1 Type = float32    NumberOfElements = 1 NumberOfDimensions = 0 }
           in4 = { DataSource = DDB1 Type = float32    NumberOfElements = 4 NumberOfDimensions = 1 }
           in5 = { DataSource = DDB1 Type = uint8      NumberOfElements = 1 }
           in5pad2 = { DataSource = DDB1 Type = uint8      NumberOfElements = 1 }
           in5pad1 = { DataSource = DDB1 Type = uint8      NumberOfElements = 1 }
           in5pad3 = { DataSource = DDB1 Type = uint8      NumberOfElements = 1 }
           
	     }
	    }
		+GAMSimulink1 = {
 			Class = SimulinkWrapperGAM
			Library = "/home/tcv_oper/martecfgs/tests/bus_exciter1.so"			
			SymbolPrefix = "bus_exciter1"			
			Verbosity = 2
			SkipInvalidTunableParams = 0
            TunableParamExternalSource= "MDSParamLoader1"
            NonVirtualBusMode = "ByteArray" // NOTE: homogeneus buses are not handled correctly, wrong
                                            // handling of NumberOfElements = 1
            //NonVirtualBusMode = "Structured" 
            EnforceModelSignalCoverage  = 0
			InputSignals = {		
                in1 = { DataSource = DDB1 Type = uint8     NumberOfElements = 8 }
                in2 = { DataSource = DDB1 Type = uint8     NumberOfElements = 16 }
                in3 = { DataSource = DDB1 Type = float32   NumberOfElements = 1 }
                in4 = { DataSource = DDB1 Type = float32   NumberOfElements = 4 }   
                in5 = { DataSource = DDB1 Type = uint8     NumberOfElements = 1 }   
                in6 = { DataSource = DDB1 Type = uint8     NumberOfElements = 8 }
                in7 = { DataSource = DDB1 Type = float32     NumberOfElements = 2 }                
                //in2 = { DataSource = DDB1 Type = uint8      NumberOfElements = 8 }                
            }
 			OutputSignals = { 
                out1 = { DataSource = DDB1 Type = uint8    NumberOfElements = 8  NumberOfDimensions = 1 }
                out2 = { DataSource = DDB1 Type = uint8    NumberOfElements = 16 NumberOfDimensions = 1 }
                out3 = { DataSource = DDB1 Type = float32  NumberOfElements = 1  NumberOfDimensions = 0 }
                out4 = { DataSource = DDB1 Type = float32  NumberOfElements = 4  NumberOfDimensions = 1 }   
                out5 = { DataSource = DDB1 Type = uint8    NumberOfElements = 1  NumberOfDimensions = 0 }   
                out6 = { DataSource = DDB1 Type = uint8    NumberOfElements = 8  NumberOfDimensions = 1 }
                out7 = { DataSource = DDB1 Type = float32    NumberOfElements = 2  NumberOfDimensions = 1 }
            }
            /*
			Parameters    =  {
                k1 = (float32) 2.5
            }
            */
		}
		+LoggerBroker = {
		 Class = IOGAM
		 InputSignals = {
                out1 = { DataSource = DDB1 Type = uint8    NumberOfElements = 8  NumberOfDimensions = 1 }
                out3 = { DataSource = DDB1  Type = float32  NumberOfElements = 1 NumberOfDimensions = 0 }
                out4 = { DataSource = DDB1 Type = float32   NumberOfElements = 4 NumberOfDimensions = 1 }
                out5 = { DataSource = DDB1 Type = uint8     NumberOfElements = 1 NumberOfDimensions = 0 } 
		 }
		 OutputSignals = {
                out1f = { DataSource = Logger Type = float32    NumberOfElements = 1  NumberOfDimensions = 0 }
                out1i = { DataSource = Logger Type = uint8    NumberOfElements = 4  NumberOfDimensions = 1 }
                
		        out3 = { DataSource = Logger Type = float32  NumberOfElements = 1 NumberOfDimensions = 0 }
		        out4 = { DataSource = Logger Type = float32  NumberOfElements = 4 NumberOfDimensions = 1 }
                out5 = { DataSource = Logger Type = uint8     NumberOfElements = 1 NumberOfDimensions = 0 } 		        
		 }
		}
    }
    +Data = {
        Class = ReferenceContainer
        DefaultDataSource = DDB1
        +DDB1 = { Class = GAMDataSource }    
        +Logger = { Class = LoggerDataSource }
        +Timings = { Class = TimingDataSource }
        +Timer = {
            Class = LinuxTimer
            SleepNature = "Busy" // Default | Busy
            ExecutionMode = IndependentThread // IndependentThread | RealTimeThread
            CPUMask = 0x8 // IndependentThread CPU mask
            Signals = {
                Counter = { Type = uint32 }
                Time = { Type = uint32 }
            }
        }
    }
    +States = {
        Class = ReferenceContainer
        +State1 = {
            Class = RealTimeState
            +Threads = {
                Class = ReferenceContainer
                +Thread1 = {
                    Class = RealTimeThread 
                    CPUs = 0x4
                    Functions = {
                      GAMTimer  
                      TimeConversion
                      Constants
                      BusExciter
                      GAMSimulink1
                      LoggerBroker
                    }
                }
            }
        }        
    }
    +Scheduler = {
        Class = GAMScheduler
        TimingDataSource = Timings
    }
}
